#include <unistd.h>
#include <signal.h>
#include <stdio.h>
#include <syslog.h>
#include <varargs.h>
#include <string.h>

static unsigned long save[10];
static unsigned long saveip[10];
static unsigned invflag=0;
extern char* __progname;

static unsigned
getbp()
{ 
	__asm__("movl %ebp,%eax");
	__asm__("movl (%eax),%eax");
}

#define SUICIDE \
	openlog(__progname,LOG_NDELAY|LOG_PERROR|LOG_PID|LOG_CONS,LOG_USER);\
        syslog(LOG_ERR,"Stack violation - exiting");\
        closelog();\
        kill(SIGSEGV,getpid());\
        exit(1) ;\

#ifdef PARANOIDAL_ROOT
static int paranoidal_check=-1;
#endif

void
enter_violation()
{ 
	int i;
	unsigned bp=getbp();

#ifdef PARANOIDAL_ROOT
	if(paranoidal_check==-1) 
		paranoidal_check=issetugid()||(!geteuid())||(!getuid());
	if(!paranoidal_check) return; 
#endif

	invflag++;
	if(invflag>1) return;
	bzero(save,sizeof(save));
	bzero(saveip,sizeof(saveip));
	bp=*((unsigned*)bp);
	for(i=0;i<10;i++) { 
#if defined(PRINTF_DEBUGINFO)
		printf("saving %lux (%i)\n",bp,invflag);
#endif
		save[i]=bp;
		if(!bp) break;
		/* this is bogus, but... Sometimes we got stack entries
		 * points to low addresses. 0x20000000 - is a shared 
		 * library maping start */ 
		if(bp<0x20000000) {
			save[i]=0;
			break;
		};
		saveip[i]=*((long unsigned*)bp+1);
		bp=*(long unsigned*)bp;
	}; 
};

void 
exit_violation()
{ 
	int i;
	unsigned bp=getbp();

#ifdef PARANOIDAL_ROOT
	/* at exit_violation we always have paranoidal_check set to 0 or 1 */
	if(!paranoidal_check) return; 
#endif

	if(invflag>1) { 
		invflag--;
		return;
	};
	bp=*((unsigned*)bp);
	for(i=0;i<10;i++) { 
#if defined(PRINTF_DEBUGINFO)
		printf("processing %x (%i)\n",bp,invflag);
#endif
		if(!save[i]) break;
		if(bp!=save[i]) { 
			SUICIDE;
		};
		if(!bp) break;
#if defined(PRINTF_DEBUGINFO)
		printf("restoring ip %lux : %x \n",saveip[i],*((unsigned*)bp+1));
#endif
		if(saveip[i]!=*((unsigned*)bp+1)) { 
			SUICIDE;
		};
		bp=*(unsigned*)bp;
	};
	invflag--;
	return;
};
